#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/vt.h>
/*
 * Temp bogl functions at upper level.  All these need to move
 * to the driver level, just like vgalib does.
 */

int	vterm;			/* the VT we were started on */
int 	cvt, ocvt;

/* entry points*/
void 	bogl_InitVt(void);
int  	bogl_CurrentVt(void);
int  	bogl_CheckVtChange(void);
void 	bogl_RedrawVt(int t);

void
bogl_InitVt(void)
{
	cvt = ocvt = vterm = bogl_CurrentVt();
	/*
	 * Note: this hack is required to get Linux
	 * to orient virtual 0,0 with physical 0,0
	 * I have no idea why this kluge is required...
	 */
	bogl_RedrawVt(vterm);
}

/*
 * This function is used to find out what the current active VT is.
 */
int bogl_CurrentVt(void)
{
	int n;
	struct vt_stat stat;

	n = open("/dev/tty0", O_RDONLY);
	ioctl(n, VT_GETSTATE, &stat);
	close(n);
	return stat.v_active;
}

/*
 * Check if our VT has changed.  Return 1 if so.
 */
int
bogl_CheckVtChange(void)
{
	cvt = bogl_CurrentVt();
	if(cvt != ocvt && cvt == vterm) {
		ocvt = cvt;
		return 1;
	}
	ocvt = cvt;
	return 0;
}

/*
 * This function is used to cause a redraw of the text console.
 * FIXME: I can't work out how to do this- the kernel has the info I want,
 * but I can't figure out how to get it. Switching to another console and
 * back works, but that's a really dirty hack
 */
void bogl_RedrawVt(int t)
{
	int n;

	if(bogl_CurrentVt() == vterm) {
		n = open("/dev/tty0", O_RDONLY);
		ioctl(n, VT_ACTIVATE, t == 1 ? 2 : 1); /* Awful hack!!*/
		ioctl(n, VT_ACTIVATE, t);
		close(n);
	}
}
